/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.adaptation.Action;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.Parameter;

import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPoint;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.ActionImpl#getOutputParam <em>Output Param</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.ActionImpl#getInputParams <em>Input Params</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.ActionImpl#getReferredAdaptationPoint <em>Referred Adaptation Point</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.ActionImpl#getAdaptationActionOperation <em>Adaptation Action Operation</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ActionImpl extends EntityImpl implements Action {
    /**
	 * The cached value of the '{@link #getOutputParam() <em>Output Param</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getOutputParam()
	 * @generated
	 * @ordered
	 */
    protected Parameter outputParam;

    /**
	 * The cached value of the '{@link #getInputParams() <em>Input Params</em>}' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getInputParams()
	 * @generated
	 * @ordered
	 */
    protected EList<Parameter> inputParams;

    /**
	 * The cached value of the '{@link #getReferredAdaptationPoint() <em>Referred Adaptation Point</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getReferredAdaptationPoint()
	 * @generated
	 * @ordered
	 */
    protected AdaptationPoint referredAdaptationPoint;

    /**
	 * The cached value of the '{@link #getAdaptationActionOperation() <em>Adaptation Action Operation</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getAdaptationActionOperation()
	 * @generated
	 * @ordered
	 */
    protected AdaptationActionOperation adaptationActionOperation;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ActionImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return AdaptationPackage.Literals.ACTION;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Parameter getOutputParam() {
		if (outputParam != null && outputParam.eIsProxy()) {
			InternalEObject oldOutputParam = (InternalEObject)outputParam;
			outputParam = (Parameter)eResolveProxy(oldOutputParam);
			if (outputParam != oldOutputParam) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdaptationPackage.ACTION__OUTPUT_PARAM, oldOutputParam, outputParam));
			}
		}
		return outputParam;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Parameter basicGetOutputParam() {
		return outputParam;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setOutputParam(Parameter newOutputParam) {
		Parameter oldOutputParam = outputParam;
		outputParam = newOutputParam;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.ACTION__OUTPUT_PARAM, oldOutputParam, outputParam));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList<Parameter> getInputParams() {
		if (inputParams == null) {
			inputParams = new EObjectResolvingEList<Parameter>(Parameter.class, this, AdaptationPackage.ACTION__INPUT_PARAMS);
		}
		return inputParams;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptationPoint getReferredAdaptationPoint() {
		if (referredAdaptationPoint != null && referredAdaptationPoint.eIsProxy()) {
			InternalEObject oldReferredAdaptationPoint = (InternalEObject)referredAdaptationPoint;
			referredAdaptationPoint = (AdaptationPoint)eResolveProxy(oldReferredAdaptationPoint);
			if (referredAdaptationPoint != oldReferredAdaptationPoint) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdaptationPackage.ACTION__REFERRED_ADAPTATION_POINT, oldReferredAdaptationPoint, referredAdaptationPoint));
			}
		}
		return referredAdaptationPoint;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptationPoint basicGetReferredAdaptationPoint() {
		return referredAdaptationPoint;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setReferredAdaptationPoint(AdaptationPoint newReferredAdaptationPoint) {
		AdaptationPoint oldReferredAdaptationPoint = referredAdaptationPoint;
		referredAdaptationPoint = newReferredAdaptationPoint;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.ACTION__REFERRED_ADAPTATION_POINT, oldReferredAdaptationPoint, referredAdaptationPoint));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptationActionOperation getAdaptationActionOperation() {
		return adaptationActionOperation;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetAdaptationActionOperation(AdaptationActionOperation newAdaptationActionOperation, NotificationChain msgs) {
		AdaptationActionOperation oldAdaptationActionOperation = adaptationActionOperation;
		adaptationActionOperation = newAdaptationActionOperation;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdaptationPackage.ACTION__ADAPTATION_ACTION_OPERATION, oldAdaptationActionOperation, newAdaptationActionOperation);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setAdaptationActionOperation(AdaptationActionOperation newAdaptationActionOperation) {
		if (newAdaptationActionOperation != adaptationActionOperation) {
			NotificationChain msgs = null;
			if (adaptationActionOperation != null)
				msgs = ((InternalEObject)adaptationActionOperation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.ACTION__ADAPTATION_ACTION_OPERATION, null, msgs);
			if (newAdaptationActionOperation != null)
				msgs = ((InternalEObject)newAdaptationActionOperation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.ACTION__ADAPTATION_ACTION_OPERATION, null, msgs);
			msgs = basicSetAdaptationActionOperation(newAdaptationActionOperation, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.ACTION__ADAPTATION_ACTION_OPERATION, newAdaptationActionOperation, newAdaptationActionOperation));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdaptationPackage.ACTION__ADAPTATION_ACTION_OPERATION:
				return basicSetAdaptationActionOperation(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdaptationPackage.ACTION__OUTPUT_PARAM:
				if (resolve) return getOutputParam();
				return basicGetOutputParam();
			case AdaptationPackage.ACTION__INPUT_PARAMS:
				return getInputParams();
			case AdaptationPackage.ACTION__REFERRED_ADAPTATION_POINT:
				if (resolve) return getReferredAdaptationPoint();
				return basicGetReferredAdaptationPoint();
			case AdaptationPackage.ACTION__ADAPTATION_ACTION_OPERATION:
				return getAdaptationActionOperation();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdaptationPackage.ACTION__OUTPUT_PARAM:
				setOutputParam((Parameter)newValue);
				return;
			case AdaptationPackage.ACTION__INPUT_PARAMS:
				getInputParams().clear();
				getInputParams().addAll((Collection<? extends Parameter>)newValue);
				return;
			case AdaptationPackage.ACTION__REFERRED_ADAPTATION_POINT:
				setReferredAdaptationPoint((AdaptationPoint)newValue);
				return;
			case AdaptationPackage.ACTION__ADAPTATION_ACTION_OPERATION:
				setAdaptationActionOperation((AdaptationActionOperation)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case AdaptationPackage.ACTION__OUTPUT_PARAM:
				setOutputParam((Parameter)null);
				return;
			case AdaptationPackage.ACTION__INPUT_PARAMS:
				getInputParams().clear();
				return;
			case AdaptationPackage.ACTION__REFERRED_ADAPTATION_POINT:
				setReferredAdaptationPoint((AdaptationPoint)null);
				return;
			case AdaptationPackage.ACTION__ADAPTATION_ACTION_OPERATION:
				setAdaptationActionOperation((AdaptationActionOperation)null);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdaptationPackage.ACTION__OUTPUT_PARAM:
				return outputParam != null;
			case AdaptationPackage.ACTION__INPUT_PARAMS:
				return inputParams != null && !inputParams.isEmpty();
			case AdaptationPackage.ACTION__REFERRED_ADAPTATION_POINT:
				return referredAdaptationPoint != null;
			case AdaptationPackage.ACTION__ADAPTATION_ACTION_OPERATION:
				return adaptationActionOperation != null;
		}
		return super.eIsSet(featureID);
	}

} //ActionImpl
