/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.impl;

import edu.kit.ipd.descartes.core.Entity;

import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationPlan;
import edu.kit.ipd.descartes.mm.adaptation.BranchAction;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Branch Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.BranchActionImpl#getContext <em>Context</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.BranchActionImpl#getCondition <em>Condition</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.BranchActionImpl#getConditionTrueBranch <em>Condition True Branch</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.BranchActionImpl#getConditionFalseBranch <em>Condition False Branch</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BranchActionImpl extends AbstractControlFlowElementImpl implements BranchAction {
    /**
	 * The cached value of the '{@link #getContext() <em>Context</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getContext()
	 * @generated
	 * @ordered
	 */
    protected Entity context;

    /**
	 * The default value of the '{@link #getCondition() <em>Condition</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getCondition()
	 * @generated
	 * @ordered
	 */
    protected static final String CONDITION_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getCondition() <em>Condition</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getCondition()
	 * @generated
	 * @ordered
	 */
    protected String condition = CONDITION_EDEFAULT;

    /**
	 * The cached value of the '{@link #getConditionTrueBranch() <em>Condition True Branch</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getConditionTrueBranch()
	 * @generated
	 * @ordered
	 */
    protected AdaptationPlan conditionTrueBranch;

    /**
	 * The cached value of the '{@link #getConditionFalseBranch() <em>Condition False Branch</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getConditionFalseBranch()
	 * @generated
	 * @ordered
	 */
    protected AdaptationPlan conditionFalseBranch;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected BranchActionImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return AdaptationPackage.Literals.BRANCH_ACTION;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Entity getContext() {
		if (context != null && context.eIsProxy()) {
			InternalEObject oldContext = (InternalEObject)context;
			context = (Entity)eResolveProxy(oldContext);
			if (context != oldContext) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdaptationPackage.BRANCH_ACTION__CONTEXT, oldContext, context));
			}
		}
		return context;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Entity basicGetContext() {
		return context;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setContext(Entity newContext) {
		Entity oldContext = context;
		context = newContext;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.BRANCH_ACTION__CONTEXT, oldContext, context));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String getCondition() {
		return condition;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setCondition(String newCondition) {
		String oldCondition = condition;
		condition = newCondition;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.BRANCH_ACTION__CONDITION, oldCondition, condition));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptationPlan getConditionTrueBranch() {
		return conditionTrueBranch;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetConditionTrueBranch(AdaptationPlan newConditionTrueBranch, NotificationChain msgs) {
		AdaptationPlan oldConditionTrueBranch = conditionTrueBranch;
		conditionTrueBranch = newConditionTrueBranch;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdaptationPackage.BRANCH_ACTION__CONDITION_TRUE_BRANCH, oldConditionTrueBranch, newConditionTrueBranch);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setConditionTrueBranch(AdaptationPlan newConditionTrueBranch) {
		if (newConditionTrueBranch != conditionTrueBranch) {
			NotificationChain msgs = null;
			if (conditionTrueBranch != null)
				msgs = ((InternalEObject)conditionTrueBranch).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.BRANCH_ACTION__CONDITION_TRUE_BRANCH, null, msgs);
			if (newConditionTrueBranch != null)
				msgs = ((InternalEObject)newConditionTrueBranch).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.BRANCH_ACTION__CONDITION_TRUE_BRANCH, null, msgs);
			msgs = basicSetConditionTrueBranch(newConditionTrueBranch, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.BRANCH_ACTION__CONDITION_TRUE_BRANCH, newConditionTrueBranch, newConditionTrueBranch));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptationPlan getConditionFalseBranch() {
		return conditionFalseBranch;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetConditionFalseBranch(AdaptationPlan newConditionFalseBranch, NotificationChain msgs) {
		AdaptationPlan oldConditionFalseBranch = conditionFalseBranch;
		conditionFalseBranch = newConditionFalseBranch;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdaptationPackage.BRANCH_ACTION__CONDITION_FALSE_BRANCH, oldConditionFalseBranch, newConditionFalseBranch);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setConditionFalseBranch(AdaptationPlan newConditionFalseBranch) {
		if (newConditionFalseBranch != conditionFalseBranch) {
			NotificationChain msgs = null;
			if (conditionFalseBranch != null)
				msgs = ((InternalEObject)conditionFalseBranch).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.BRANCH_ACTION__CONDITION_FALSE_BRANCH, null, msgs);
			if (newConditionFalseBranch != null)
				msgs = ((InternalEObject)newConditionFalseBranch).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.BRANCH_ACTION__CONDITION_FALSE_BRANCH, null, msgs);
			msgs = basicSetConditionFalseBranch(newConditionFalseBranch, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.BRANCH_ACTION__CONDITION_FALSE_BRANCH, newConditionFalseBranch, newConditionFalseBranch));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdaptationPackage.BRANCH_ACTION__CONDITION_TRUE_BRANCH:
				return basicSetConditionTrueBranch(null, msgs);
			case AdaptationPackage.BRANCH_ACTION__CONDITION_FALSE_BRANCH:
				return basicSetConditionFalseBranch(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdaptationPackage.BRANCH_ACTION__CONTEXT:
				if (resolve) return getContext();
				return basicGetContext();
			case AdaptationPackage.BRANCH_ACTION__CONDITION:
				return getCondition();
			case AdaptationPackage.BRANCH_ACTION__CONDITION_TRUE_BRANCH:
				return getConditionTrueBranch();
			case AdaptationPackage.BRANCH_ACTION__CONDITION_FALSE_BRANCH:
				return getConditionFalseBranch();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdaptationPackage.BRANCH_ACTION__CONTEXT:
				setContext((Entity)newValue);
				return;
			case AdaptationPackage.BRANCH_ACTION__CONDITION:
				setCondition((String)newValue);
				return;
			case AdaptationPackage.BRANCH_ACTION__CONDITION_TRUE_BRANCH:
				setConditionTrueBranch((AdaptationPlan)newValue);
				return;
			case AdaptationPackage.BRANCH_ACTION__CONDITION_FALSE_BRANCH:
				setConditionFalseBranch((AdaptationPlan)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case AdaptationPackage.BRANCH_ACTION__CONTEXT:
				setContext((Entity)null);
				return;
			case AdaptationPackage.BRANCH_ACTION__CONDITION:
				setCondition(CONDITION_EDEFAULT);
				return;
			case AdaptationPackage.BRANCH_ACTION__CONDITION_TRUE_BRANCH:
				setConditionTrueBranch((AdaptationPlan)null);
				return;
			case AdaptationPackage.BRANCH_ACTION__CONDITION_FALSE_BRANCH:
				setConditionFalseBranch((AdaptationPlan)null);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdaptationPackage.BRANCH_ACTION__CONTEXT:
				return context != null;
			case AdaptationPackage.BRANCH_ACTION__CONDITION:
				return CONDITION_EDEFAULT == null ? condition != null : !CONDITION_EDEFAULT.equals(condition);
			case AdaptationPackage.BRANCH_ACTION__CONDITION_TRUE_BRANCH:
				return conditionTrueBranch != null;
			case AdaptationPackage.BRANCH_ACTION__CONDITION_FALSE_BRANCH:
				return conditionFalseBranch != null;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (condition: ");
		result.append(condition);
		result.append(')');
		return result.toString();
	}

} //BranchActionImpl
