/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourceconfiguration;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Active Resource Specification</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourceconfiguration.ActiveResourceSpecification#getProcessingResourceSpecifications <em>Processing Resource Specifications</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourceconfiguration.ActiveResourceSpecification#getLinkingResources <em>Linking Resources</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationPackage#getActiveResourceSpecification()
 * @model
 * @generated
 */
public interface ActiveResourceSpecification extends ConfigurationSpecification {
	/**
	 * Returns the value of the '<em><b>Processing Resource Specifications</b></em>' containment reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.resourceconfiguration.ProcessingResourceSpecification}.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.ProcessingResourceSpecification#getParentResourceSpecification <em>Parent Resource Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Processing Resource Specifications</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Processing Resource Specifications</em>' containment reference list.
	 * @see edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationPackage#getActiveResourceSpecification_ProcessingResourceSpecifications()
	 * @see edu.kit.ipd.descartes.mm.resourceconfiguration.ProcessingResourceSpecification#getParentResourceSpecification
	 * @model opposite="parentResourceSpecification" containment="true" ordered="false"
	 * @generated
	 */
	EList<ProcessingResourceSpecification> getProcessingResourceSpecifications();

	/**
	 * Returns the value of the '<em><b>Linking Resources</b></em>' containment reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.resourceconfiguration.LinkingResourceSpecification}.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.LinkingResourceSpecification#getParentResourceConfiguration <em>Parent Resource Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Linking Resources</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Linking Resources</em>' containment reference list.
	 * @see edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationPackage#getActiveResourceSpecification_LinkingResources()
	 * @see edu.kit.ipd.descartes.mm.resourceconfiguration.LinkingResourceSpecification#getParentResourceConfiguration
	 * @model opposite="parentResourceConfiguration" containment="true" ordered="false"
	 * @generated
	 */
	EList<LinkingResourceSpecification> getLinkingResources();

} // ActiveResourceSpecification
