/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourceconfiguration.impl;

import edu.kit.ipd.descartes.mm.resourceconfiguration.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ResourceconfigurationFactoryImpl extends EFactoryImpl implements ResourceconfigurationFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ResourceconfigurationFactory init() {
		try {
			ResourceconfigurationFactory theResourceconfigurationFactory = (ResourceconfigurationFactory)EPackage.Registry.INSTANCE.getEFactory(ResourceconfigurationPackage.eNS_URI);
			if (theResourceconfigurationFactory != null) {
				return theResourceconfigurationFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new ResourceconfigurationFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceconfigurationFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION: return createProcessingResourceSpecification();
			case ResourceconfigurationPackage.NUMBER_OF_PARALLEL_PROCESSING_UNITS: return createNumberOfParallelProcessingUnits();
			case ResourceconfigurationPackage.LINKING_RESOURCE_SPECIFICATION: return createLinkingResourceSpecification();
			case ResourceconfigurationPackage.ACTIVE_RESOURCE_SPECIFICATION: return createActiveResourceSpecification();
			case ResourceconfigurationPackage.CUSTOM_CONFIGURATION_SPECIFICATION: return createCustomConfigurationSpecification();
			case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION: return createPassiveResourceSpecification();
			case ResourceconfigurationPackage.PASSIVE_RESOURCE_CAPACITY: return createPassiveResourceCapacity();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case ResourceconfigurationPackage.SCHEDULING_POLICY:
				return createSchedulingPolicyFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case ResourceconfigurationPackage.SCHEDULING_POLICY:
				return convertSchedulingPolicyToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessingResourceSpecification createProcessingResourceSpecification() {
		ProcessingResourceSpecificationImpl processingResourceSpecification = new ProcessingResourceSpecificationImpl();
		return processingResourceSpecification;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NumberOfParallelProcessingUnits createNumberOfParallelProcessingUnits() {
		NumberOfParallelProcessingUnitsImpl numberOfParallelProcessingUnits = new NumberOfParallelProcessingUnitsImpl();
		return numberOfParallelProcessingUnits;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LinkingResourceSpecification createLinkingResourceSpecification() {
		LinkingResourceSpecificationImpl linkingResourceSpecification = new LinkingResourceSpecificationImpl();
		return linkingResourceSpecification;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ActiveResourceSpecification createActiveResourceSpecification() {
		ActiveResourceSpecificationImpl activeResourceSpecification = new ActiveResourceSpecificationImpl();
		return activeResourceSpecification;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CustomConfigurationSpecification createCustomConfigurationSpecification() {
		CustomConfigurationSpecificationImpl customConfigurationSpecification = new CustomConfigurationSpecificationImpl();
		return customConfigurationSpecification;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PassiveResourceSpecification createPassiveResourceSpecification() {
		PassiveResourceSpecificationImpl passiveResourceSpecification = new PassiveResourceSpecificationImpl();
		return passiveResourceSpecification;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PassiveResourceCapacity createPassiveResourceCapacity() {
		PassiveResourceCapacityImpl passiveResourceCapacity = new PassiveResourceCapacityImpl();
		return passiveResourceCapacity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SchedulingPolicy createSchedulingPolicyFromString(EDataType eDataType, String initialValue) {
		SchedulingPolicy result = SchedulingPolicy.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertSchedulingPolicyToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceconfigurationPackage getResourceconfigurationPackage() {
		return (ResourceconfigurationPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static ResourceconfigurationPackage getPackage() {
		return ResourceconfigurationPackage.eINSTANCE;
	}

} //ResourceconfigurationFactoryImpl
