/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcelandscape.util;

import edu.kit.ipd.descartes.core.Entity;
import edu.kit.ipd.descartes.core.NamedElement;

import edu.kit.ipd.descartes.identifier.Identifier;

import edu.kit.ipd.descartes.mm.resourcelandscape.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage
 * @generated
 */
public class ResourcelandscapeSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static ResourcelandscapePackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourcelandscapeSwitch() {
		if (modelPackage == null) {
			modelPackage = ResourcelandscapePackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case ResourcelandscapePackage.COMPUTING_INFRASTRUCTURE: {
				ComputingInfrastructure computingInfrastructure = (ComputingInfrastructure)theEObject;
				T result = caseComputingInfrastructure(computingInfrastructure);
				if (result == null) result = caseContainer(computingInfrastructure);
				if (result == null) result = caseHardwareInfrastructure(computingInfrastructure);
				if (result == null) result = caseEntity(computingInfrastructure);
				if (result == null) result = caseIdentifier(computingInfrastructure);
				if (result == null) result = caseNamedElement(computingInfrastructure);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ResourcelandscapePackage.NETWORKING_INFRASTRUCTURE: {
				NetworkingInfrastructure networkingInfrastructure = (NetworkingInfrastructure)theEObject;
				T result = caseNetworkingInfrastructure(networkingInfrastructure);
				if (result == null) result = caseContainer(networkingInfrastructure);
				if (result == null) result = caseHardwareInfrastructure(networkingInfrastructure);
				if (result == null) result = caseEntity(networkingInfrastructure);
				if (result == null) result = caseIdentifier(networkingInfrastructure);
				if (result == null) result = caseNamedElement(networkingInfrastructure);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ResourcelandscapePackage.STORAGE_INFRASTRUCTURE: {
				StorageInfrastructure storageInfrastructure = (StorageInfrastructure)theEObject;
				T result = caseStorageInfrastructure(storageInfrastructure);
				if (result == null) result = caseContainer(storageInfrastructure);
				if (result == null) result = caseHardwareInfrastructure(storageInfrastructure);
				if (result == null) result = caseEntity(storageInfrastructure);
				if (result == null) result = caseIdentifier(storageInfrastructure);
				if (result == null) result = caseNamedElement(storageInfrastructure);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ResourcelandscapePackage.CONTAINER: {
				Container container = (Container)theEObject;
				T result = caseContainer(container);
				if (result == null) result = caseEntity(container);
				if (result == null) result = caseIdentifier(container);
				if (result == null) result = caseNamedElement(container);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ResourcelandscapePackage.RUNTIME_ENVIRONMENT: {
				RuntimeEnvironment runtimeEnvironment = (RuntimeEnvironment)theEObject;
				T result = caseRuntimeEnvironment(runtimeEnvironment);
				if (result == null) result = caseContainer(runtimeEnvironment);
				if (result == null) result = caseEntity(runtimeEnvironment);
				if (result == null) result = caseIdentifier(runtimeEnvironment);
				if (result == null) result = caseNamedElement(runtimeEnvironment);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ResourcelandscapePackage.DATA_CENTER: {
				DataCenter dataCenter = (DataCenter)theEObject;
				T result = caseDataCenter(dataCenter);
				if (result == null) result = caseEntity(dataCenter);
				if (result == null) result = caseIdentifier(dataCenter);
				if (result == null) result = caseNamedElement(dataCenter);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ResourcelandscapePackage.DISTRIBUTED_DATA_CENTER: {
				DistributedDataCenter distributedDataCenter = (DistributedDataCenter)theEObject;
				T result = caseDistributedDataCenter(distributedDataCenter);
				if (result == null) result = caseEntity(distributedDataCenter);
				if (result == null) result = caseIdentifier(distributedDataCenter);
				if (result == null) result = caseNamedElement(distributedDataCenter);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ResourcelandscapePackage.COMPOSITE_HARDWARE_INFRASTRUCTURE: {
				CompositeHardwareInfrastructure compositeHardwareInfrastructure = (CompositeHardwareInfrastructure)theEObject;
				T result = caseCompositeHardwareInfrastructure(compositeHardwareInfrastructure);
				if (result == null) result = caseHardwareInfrastructure(compositeHardwareInfrastructure);
				if (result == null) result = caseEntity(compositeHardwareInfrastructure);
				if (result == null) result = caseIdentifier(compositeHardwareInfrastructure);
				if (result == null) result = caseNamedElement(compositeHardwareInfrastructure);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ResourcelandscapePackage.HARDWARE_INFRASTRUCTURE: {
				HardwareInfrastructure hardwareInfrastructure = (HardwareInfrastructure)theEObject;
				T result = caseHardwareInfrastructure(hardwareInfrastructure);
				if (result == null) result = caseEntity(hardwareInfrastructure);
				if (result == null) result = caseIdentifier(hardwareInfrastructure);
				if (result == null) result = caseNamedElement(hardwareInfrastructure);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Computing Infrastructure</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Computing Infrastructure</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseComputingInfrastructure(ComputingInfrastructure object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Networking Infrastructure</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Networking Infrastructure</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetworkingInfrastructure(NetworkingInfrastructure object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Storage Infrastructure</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Storage Infrastructure</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStorageInfrastructure(StorageInfrastructure object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Container</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Container</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseContainer(Container object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Runtime Environment</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Runtime Environment</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRuntimeEnvironment(RuntimeEnvironment object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Data Center</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Data Center</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDataCenter(DataCenter object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Distributed Data Center</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Distributed Data Center</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDistributedDataCenter(DistributedDataCenter object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Composite Hardware Infrastructure</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Composite Hardware Infrastructure</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCompositeHardwareInfrastructure(CompositeHardwareInfrastructure object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Hardware Infrastructure</em>'.
	 * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Hardware Infrastructure</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseHardwareInfrastructure(HardwareInfrastructure object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Identifier</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Identifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIdentifier(Identifier object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Named Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNamedElement(NamedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Entity</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Entity</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEntity(Entity object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //ResourcelandscapeSwitch
