/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcetype;

import edu.kit.ipd.descartes.core.CorePackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.resourcetype.ResourcetypeFactory
 * @model kind="package"
 * @generated
 */
public interface ResourcetypePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "resourcetype";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes-research.net/metamodel/resourcetype/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "resourcetype";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ResourcetypePackage eINSTANCE = edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl.init();

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.ResourceTypeRepositoryImpl <em>Resource Type Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourceTypeRepositoryImpl
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getResourceTypeRepository()
	 * @generated
	 */
	int RESOURCE_TYPE_REPOSITORY = 0;

	/**
	 * The feature id for the '<em><b>Resource Types</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_TYPE_REPOSITORY__RESOURCE_TYPES = 0;

	/**
	 * The number of structural features of the '<em>Resource Type Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_TYPE_REPOSITORY_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.ResourceTypeImpl <em>Resource Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourceTypeImpl
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getResourceType()
	 * @generated
	 */
	int RESOURCE_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_TYPE__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_TYPE__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Parent Resource Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_TYPE__PARENT_RESOURCE_REPOSITORY = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Resource Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_TYPE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.ProcessingResourceTypeImpl <em>Processing Resource Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ProcessingResourceTypeImpl
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getProcessingResourceType()
	 * @generated
	 */
	int PROCESSING_RESOURCE_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_RESOURCE_TYPE__ID = RESOURCE_TYPE__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_RESOURCE_TYPE__NAME = RESOURCE_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Parent Resource Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_RESOURCE_TYPE__PARENT_RESOURCE_REPOSITORY = RESOURCE_TYPE__PARENT_RESOURCE_REPOSITORY;

	/**
	 * The number of structural features of the '<em>Processing Resource Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_RESOURCE_TYPE_FEATURE_COUNT = RESOURCE_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.CommunicationLinkResourceTypeImpl <em>Communication Link Resource Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.CommunicationLinkResourceTypeImpl
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getCommunicationLinkResourceType()
	 * @generated
	 */
	int COMMUNICATION_LINK_RESOURCE_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_LINK_RESOURCE_TYPE__ID = PROCESSING_RESOURCE_TYPE__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_LINK_RESOURCE_TYPE__NAME = PROCESSING_RESOURCE_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Parent Resource Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_LINK_RESOURCE_TYPE__PARENT_RESOURCE_REPOSITORY = PROCESSING_RESOURCE_TYPE__PARENT_RESOURCE_REPOSITORY;

	/**
	 * The number of structural features of the '<em>Communication Link Resource Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_LINK_RESOURCE_TYPE_FEATURE_COUNT = PROCESSING_RESOURCE_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.PassiveResourceTypeImpl <em>Passive Resource Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.PassiveResourceTypeImpl
	 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getPassiveResourceType()
	 * @generated
	 */
	int PASSIVE_RESOURCE_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PASSIVE_RESOURCE_TYPE__ID = RESOURCE_TYPE__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PASSIVE_RESOURCE_TYPE__NAME = RESOURCE_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Parent Resource Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PASSIVE_RESOURCE_TYPE__PARENT_RESOURCE_REPOSITORY = RESOURCE_TYPE__PARENT_RESOURCE_REPOSITORY;

	/**
	 * The number of structural features of the '<em>Passive Resource Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PASSIVE_RESOURCE_TYPE_FEATURE_COUNT = RESOURCE_TYPE_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcetype.ResourceTypeRepository <em>Resource Type Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resource Type Repository</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcetype.ResourceTypeRepository
	 * @generated
	 */
	EClass getResourceTypeRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.resourcetype.ResourceTypeRepository#getResourceTypes <em>Resource Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Resource Types</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcetype.ResourceTypeRepository#getResourceTypes()
	 * @see #getResourceTypeRepository()
	 * @generated
	 */
	EReference getResourceTypeRepository_ResourceTypes();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcetype.ResourceType <em>Resource Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resource Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcetype.ResourceType
	 * @generated
	 */
	EClass getResourceType();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.resourcetype.ResourceType#getParentResourceRepository <em>Parent Resource Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent Resource Repository</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcetype.ResourceType#getParentResourceRepository()
	 * @see #getResourceType()
	 * @generated
	 */
	EReference getResourceType_ParentResourceRepository();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcetype.ProcessingResourceType <em>Processing Resource Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processing Resource Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcetype.ProcessingResourceType
	 * @generated
	 */
	EClass getProcessingResourceType();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcetype.CommunicationLinkResourceType <em>Communication Link Resource Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Communication Link Resource Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcetype.CommunicationLinkResourceType
	 * @generated
	 */
	EClass getCommunicationLinkResourceType();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcetype.PassiveResourceType <em>Passive Resource Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Passive Resource Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcetype.PassiveResourceType
	 * @generated
	 */
	EClass getPassiveResourceType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ResourcetypeFactory getResourcetypeFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.ResourceTypeRepositoryImpl <em>Resource Type Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourceTypeRepositoryImpl
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getResourceTypeRepository()
		 * @generated
		 */
		EClass RESOURCE_TYPE_REPOSITORY = eINSTANCE.getResourceTypeRepository();

		/**
		 * The meta object literal for the '<em><b>Resource Types</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESOURCE_TYPE_REPOSITORY__RESOURCE_TYPES = eINSTANCE.getResourceTypeRepository_ResourceTypes();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.ResourceTypeImpl <em>Resource Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourceTypeImpl
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getResourceType()
		 * @generated
		 */
		EClass RESOURCE_TYPE = eINSTANCE.getResourceType();

		/**
		 * The meta object literal for the '<em><b>Parent Resource Repository</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESOURCE_TYPE__PARENT_RESOURCE_REPOSITORY = eINSTANCE.getResourceType_ParentResourceRepository();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.ProcessingResourceTypeImpl <em>Processing Resource Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ProcessingResourceTypeImpl
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getProcessingResourceType()
		 * @generated
		 */
		EClass PROCESSING_RESOURCE_TYPE = eINSTANCE.getProcessingResourceType();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.CommunicationLinkResourceTypeImpl <em>Communication Link Resource Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.CommunicationLinkResourceTypeImpl
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getCommunicationLinkResourceType()
		 * @generated
		 */
		EClass COMMUNICATION_LINK_RESOURCE_TYPE = eINSTANCE.getCommunicationLinkResourceType();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcetype.impl.PassiveResourceTypeImpl <em>Passive Resource Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.PassiveResourceTypeImpl
		 * @see edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl#getPassiveResourceType()
		 * @generated
		 */
		EClass PASSIVE_RESOURCE_TYPE = eINSTANCE.getPassiveResourceType();

	}

} //ResourcetypePackage
