/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.perfdatarepo.impl;

import edu.kit.ipd.descartes.perfdatarepo.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class PerfdatarepoFactoryImpl extends EFactoryImpl implements PerfdatarepoFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static PerfdatarepoFactory init() {
		try {
			PerfdatarepoFactory thePerfdatarepoFactory = (PerfdatarepoFactory)EPackage.Registry.INSTANCE.getEFactory(PerfdatarepoPackage.eNS_URI);
			if (thePerfdatarepoFactory != null) {
				return thePerfdatarepoFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new PerfdatarepoFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerfdatarepoFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case PerfdatarepoPackage.PERFORMANCE_DATA_REPOSITORY: return createPerformanceDataRepository();
			case PerfdatarepoPackage.RESULT: return createResult();
			case PerfdatarepoPackage.MEASURED_ENTITY: return createMeasuredEntity();
			case PerfdatarepoPackage.METRIC_TYPE: return createMetricType();
			case PerfdatarepoPackage.METRIC_VALUE: return createMetricValue();
			case PerfdatarepoPackage.IMPACT: return createImpact();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerformanceDataRepository createPerformanceDataRepository() {
		PerformanceDataRepositoryImpl performanceDataRepository = new PerformanceDataRepositoryImpl();
		return performanceDataRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Result createResult() {
		ResultImpl result = new ResultImpl();
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MeasuredEntity createMeasuredEntity() {
		MeasuredEntityImpl measuredEntity = new MeasuredEntityImpl();
		return measuredEntity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MetricType createMetricType() {
		MetricTypeImpl metricType = new MetricTypeImpl();
		return metricType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MetricValue createMetricValue() {
		MetricValueImpl metricValue = new MetricValueImpl();
		return metricValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Impact createImpact() {
		ImpactImpl impact = new ImpactImpl();
		return impact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerfdatarepoPackage getPerfdatarepoPackage() {
		return (PerfdatarepoPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static PerfdatarepoPackage getPackage() {
		return PerfdatarepoPackage.eINSTANCE;
	}

} //PerfdatarepoFactoryImpl
